//*********************************************************************************************************************
//*                                                                                                                   *
//*     SelPath V1.0 (c) 3delite 2006                                                                                 *
//*                                                                                                                   *
//* SelPath component is free (a mention in the credits would be nice though if you use it!).                         *                                            *
//*                                                                                                                   *
//*     http://www.3delite.hu/                                                                                        *
//*                                                                                                                   *
//* If you have any of the aforementioned please email: 3delite@fly.to                                                *
//*                                                                                                                   *
//* Good coding! :)                                                                                                   *
//* 3delite                                                                                                           *
//*********************************************************************************************************************

unit SelPath;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls, ShellCtrls;

type
  TFormSelPath = class(TForm)
    ShellTreeView: TShellTreeView;
    GroupBox: TGroupBox;
    ButtonOk: TButton;
    EditPath: TEdit;
    procedure ShellTreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure ButtonOkClick(Sender: TObject);
    procedure EditPathExit(Sender: TObject);
    procedure EditPathKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure ShellTreeViewDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSelPath: TFormSelPath;

implementation

{$R *.dfm}

procedure TFormSelPath.ShellTreeViewChange(Sender: TObject; Node: TTreeNode);
begin
	EditPath.Text := IncludeTrailingPathDelimiter(ShellTreeView.Path);
end;

procedure TFormSelPath.ButtonOkClick(Sender: TObject);
begin
	EditPathExit(nil);
	Close;
end;

procedure TFormSelPath.EditPathExit(Sender: TObject);
begin
    EditPath.Text := IncludeTrailingPathDelimiter(EditPath.Text);
	if NOT ForceDirectories(EditPath.Text) then begin
    	MessageDlg('Error creating path: ' + EditPath.Text, mtError, [mbOk],0);
        Exit;
    end;
end;

procedure TFormSelPath.EditPathKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
	if Key = 13
    	then EditPathExit(nil);
end;

procedure TFormSelPath.FormShow(Sender: TObject);
begin
    Top := 60;
    Height := Screen.Height - 180;
    Left := 120;
    try
        ShellTreeView.Path := EditPath.Text;
        ShellTreeView.Selected.Expand(False);
    except
        //*
    end;
end;

procedure TFormSelPath.ShellTreeViewDblClick(Sender: TObject);
begin
    ButtonOkClick(Sender);  
end;

end.
